#ifndef _BeQuakeView_gl_H
#define _BeQuakeView_gl_H

#include <GLView.h>
#include <Path.h>

#include "quake_beos_def_gl.h"

class BeQuakeView : public BGLView
{
 public:
	BeQuakeView(int argc, char **argv, BRect R);
	~BeQuakeView();
	void Go(void);
	void AttachedToWindow();
	void DetachedFromWindow();
	void MessageReceived(BMessage *msg);
	void KeyDown(const char *bytes, int32 numBytes);
	void KeyUp(const char *bytes, int32 numBytes);
	void DispatchKeys(const char *bytes, bool down);
	void MouseDown(BPoint p);
	void MouseUp(BPoint p);
	void MouseMoved(BPoint p, uint32 t, const BMessage *msg);
	void BGetMouse(void);
private:
	int mx, my;
	int ix;
	int iy;
	BRect *mouseRect;

 	static int32 Qthread_func(void *arg);
 	thread_id quake_thread;
	int vargc;
	char **vargv;
	sem_id syncSem;
	sem_id quittingSem;
};
#endif
