#include "BeQuakeApp_gl.h"
#include "BeQuakeView_gl.h"

BeQuakeView *bv = NULL;

void BGetMouse(void);

void BGetMouse(void)
{
	if(!bv)
		bv = ((BeQuakeApp *)be_app)->GetBeQuakeView();
		
	bv->BGetMouse();
}

int scantokey[128] =
{
// NOT YET BOUND: PRINT, SCRLLCK, PAUSE, 0x69=<>| 0x22=NUM_LOCK, 
// 0x23=KP_/ 0x24=KP_* 0x25=KP_- 0x3A=KP_+ 0x5D=KP_ENTER

// Keypad:
// 0x22 0x23 0x24 0x25
// 0x37 0x38 0x39 0x3A
// 0x48 0x49 0x4A
// 0x58 0x59 0x5A 0x5D
//   0x64    0x65

//	0		1		2		3		4		5		6		7
//	8		9		A		B		C		D		E		F
	0,		K_ESCAPE,K_F1,	K_F2,	K_F3,	K_F4,	K_F5,	K_F6,		// 0
	K_F7,	K_F8,	K_F9,	K_F10,	K_F10,	K_F11,	K_F12,	0,
	0,		/*'~'*/'`',	'1',	'2',	'3',	'4',	'5',	'6',		// 1
	'7',	'8',	'9',	'0',	'-',	'=',	K_BACKSPACE,K_INS,
	K_HOME,	K_PGUP,	0,		0,		0,		0,		K_TAB,	'q',		// 2
	'w',	'e',	'r',	't',	'y',	'u',	'i',	'o',
	'p',	'[',	']',	'\\',	0,		0,		0,		0,			// 3
	0,		0,		0,		0,		'a',	's',	'd',	'f',
	'g',	'h',	'j',	'k',	'l',	';',	'\'',	K_ENTER,	// 4
	0,		0,		0,		K_SHIFT,'z',	'x',	'c',	'v',
	'b',	'n',	'm',	',',	'.',	'/',	K_SHIFT,K_UPARROW,	// 5
	0,		0,		0,		0,		K_CTRL,	K_ALT,	K_SPACE,K_ALT,
	K_CTRL,	K_LEFTARROW,K_DOWNARROW,K_RIGHTARROW,0,		0,		0,		0,			// 6
	0,		0,		0,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		0,		0,		0,		0,			// 7
	0,		0,		0,		0,		0,		0,		0,		0,

};


void Sys_SendKeyEvents(void)
{
	static	key_info keys_old;
			key_info keys_new;
	int		key;

	#define KEY_CHANGED(a) ((keys_old.key_states[(a)>>3]^keys_new.key_states[(a)>>3])&(0x80>>((a)&0x07)))
	#define KEY_PRESSED(a) (keys_new.key_states[(a)>>3]&(0x80>>((a)&0x07)))

	if(get_key_info(&keys_new) == B_OK)
	{
		for(key = 0; key < 128; key++)
		{
			if(KEY_CHANGED(key))
			{
				if(KEY_PRESSED(key))
					Key_Event(scantokey[key], true);
				else
					Key_Event(scantokey[key], false);
			}
		}
		memcpy(&keys_old, &keys_new, sizeof(key_info));
	}
}

//***************
//ShutDown - called from Sys_Exit
//***************
void ShutDown(void)
{
	be_app->PostMessage(B_QUIT_REQUESTED);
}

//*****************
//BSwapBuffers - called from GL_EndRendering
//*****************
void BSwapBuffers()
{
	if(!bv)
		bv = ((BeQuakeApp *)be_app)->GetBeQuakeView();	
	bv->SwapBuffers();
}


//******************
//MAIN
//******************
int main(int argc, char *argv[])
{
	BeQuakeApp app(argc, argv);
	app.Run();
	return 0;
}
