#include "BeQuakeWin_gl.h"

//******************
//BeQuakeWin - BDirectWindow subclass
//******************
BeQuakeWin::BeQuakeWin(int argc, char **argv, BRect r)
//	: BDirectGLWindow(r, "BeQuake", B_TITLED_WINDOW, B_NOT_RESIZABLE|B_NOT_ZOOMABLE)
	: BDirectWindow(r, "BeQuake", B_TITLED_WINDOW, B_NOT_RESIZABLE|B_NOT_ZOOMABLE)
{
//	BRect rect = Bounds();
	mv = new BeQuakeView(argc, argv, r);
	AddChild(mv);
	mv->MakeFocus(true);
//	SetFullScreen(true);
}

void BeQuakeWin::DirectConnected(direct_buffer_info *info)
{
	if(mv) 
		mv->DirectConnected(info);
	mv->EnableDirectMode(true);
}

bool BeQuakeWin::QuitRequested()
{
	SetFullScreen(false);
	if (mv) 
		mv->EnableDirectMode(false);
	be_app->PostMessage(B_QUIT_REQUESTED);
//	be_app_messanger.SendMessage(B_QUIT_REQUESTED);
	return true;
}

BeQuakeWin::~BeQuakeWin()
{
}

BeQuakeView *BeQuakeWin::GetBeQuakeView()
{
	return mv;
}
