#include <stdio.h>
#include <stdlib.h>
#include <SoundPlayer.h>
#include <MediaDefs.h>

//typedef enum {no, yes} qboolean;
typedef int qboolean;
#define no = 0
#define yes = 1

typedef struct
{
	qboolean		gamealive;
	qboolean		soundalive;
	qboolean		splitbuffer;
	int				channels;
	int				samples;				// mono samples in buffer
	int				submission_chunk;		// don't mix less than this #
	int				samplepos;				// in mono samples
	int				samplebits;
	int				speed;
	unsigned char	*buffer;
} dma_t;

extern "C" volatile dma_t *shm;
static dma_t the_shm;

extern "C"
{
int snd_inited;
qboolean SNDDMA_Init(void);
int SNDDMA_GetDMAPos(void);
void SNDDMA_Shutdown(void);
void SNDDMA_Submit(void);
void S_PaintChannels(int endtime);
}

BSoundPlayer *player;
